declare('DKAutofill', {})

local key_name_control
local delete_button_control
local delete_name_control
local tmp
tmp = KeyInfoDialog
-- Delve down to the text control holding the key name
tmp = iup.GetNextChild(tmp) -- should return hbox
tmp = iup.GetNextChild(tmp) -- should return fill
tmp = iup.GetBrother(tmp)   -- should return vbox
tmp = iup.GetNextChild(tmp) -- should return fill
tmp = iup.GetBrother(tmp)   -- should return frame
tmp = iup.GetNextChild(tmp) -- should return frame
tmp = iup.GetNextChild(tmp) -- should return vbox
tmp = iup.GetNextChild(tmp) -- should return text (This is what we want)
if (iup.GetType(tmp) ~= 'text') then OpenAlarm("DKAutofill: Error 1", "Textbox not found at expected location.\n\nThe dialog has likely changed and this plugin won't work anymore.", "OK") return end
key_name_control = tmp

-- Continue on to the Delete Key button
tmp = iup.GetBrother(tmp)   -- should return label
tmp = iup.GetBrother(tmp)   -- should return hbox
tmp = iup.GetNextChild(tmp) -- should return button
tmp = iup.GetBrother(tmp)   -- should return fill
tmp = iup.GetBrother(tmp)   -- should return button
tmp = iup.GetBrother(tmp)   -- should return fill
tmp = iup.GetBrother(tmp)   -- should return button (This is what we want)
if (iup.GetType(tmp) ~= 'button') then 
	OpenAlarm("DKAutofill: Error 2", "Button not found at expected location.\n\nThe dialog has likely changed and this plugin won't work anymore.", "OK") return 
else
	if (tmp.title ~= 'Delete Key') then OpenAlarm("DKAutofill: Error 3", "Incorrect button found at expected location.\n\nThe dialog has likely changed and this plugin won't work anymore.", "OK") return end
end
delete_button_control = tmp

-- We need to intercept the delete button's action to rewrite ShowDialog so we can manipulate the the delete dialog
-- before it is shown.  The action function isn't a call to ShowDialog so we need to perform the rewrite, then call
-- the original function, then set ShowDialog back to it's original state.
local old_delete_button_control_action = delete_button_control.action

local function new_action(...)
	local old_ShowDialog = ShowDialog
	function ShowDialog(udata, posx, posy)
		local warning_label
		tmp = udata
		tmp = iup.GetNextChild(tmp) -- should return hbox
		tmp = iup.GetNextChild(tmp) -- should return fill
		tmp = iup.GetBrother(tmp)   -- should return vbox
		tmp = iup.GetNextChild(tmp) -- should return fill
		tmp = iup.GetBrother(tmp)   -- should return frame
		tmp = iup.GetNextChild(tmp) -- should return frame
		tmp = iup.GetNextChild(tmp) -- should return vbox
		tmp = iup.GetNextChild(tmp) -- should return label
		if (iup.GetType(tmp) ~= 'label') then 
			OpenAlarm("DKAutofill: Error 4", "Label not found at expected location.\n\nThe dialog has likely changed and this plugin won't work anymore.\nChanges made by the plugin have been reversed.", "OK") 
			delete_button_control.action = old_delete_button_control_action
			return 
		end
		tmp.old_message = tmp.title
		tmp.title = tmp.title:gsub("Are", "\127ff0000You are using the DKAutofill plugin, which has bypassed the orig-\ninal key deletion failsafe.  Do NOT ask the developers for help\nrecovering a key deleted by accident.\127o\n\nAre")
		warning_label = tmp
		tmp = iup.GetBrother(tmp)   -- should return text (This is what we want)
		if (iup.GetType(tmp) ~= 'text') then 
			OpenAlarm("DKAutofill: Error 5", "Textbox not found at expected location.\n\nThe dialog has likely changed and this plugin won't work anymore.\nChanges made by the plugin have been reversed.", "OK") 
			delete_button_control.action = old_delete_button_control_action
			warning_label.title = warning_label.old_message
			return 
		end
		tmp.value = key_name_control.value
		tmp = iup.GetBrother(tmp)   -- should return label
		-- This dialog will be destroyed when it closes, clear the reference when done.
		tmp = nil
		old_ShowDialog(udata, posx, posy)
	end

	old_delete_button_control_action(...)
	ShowDialog = old_ShowDialog
end
	
delete_button_control.action = new_action

local function deleteallkeys()
	local deletelist = {}
	for index = 1, GetNumKeysInKeychain() do
		local keyid, desc = GetKeyInfo(index)
		deletelist[keyid] = desc
	end
	for keyid, desc in pairs(deletelist) do
		Keychain.deletekey(keyid, desc)
	end
end

RegisterUserCommand('deleteallkeys', deleteallkeys)